﻿using Acr.UserDialogs;
using Finimpresa;
using Finimpresa.ViewModels;
using Syncfusion.DataSource;
using Syncfusion.ListView.XForms;
using Syncfusion.XForms.EffectsView;
using Syncfusion.XForms.Shimmer;
using Syncfusion.XForms.TabView;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Linq;
using System.Reflection;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace Finimpresa
{
    [XamlCompilation(XamlCompilationOptions.Compile)]
    public partial class Home : ContentPage
    {

        public Home()
        {
            InitializeComponent();
            pullToRefresh.Refreshing += PullToRefresh_Refreshing;
            tab.SelectionChanged += SfTabView_SelectionChanged;
        }

        private void SfTabView_SelectionChanged(object sender, Syncfusion.XForms.TabView.SelectionChangedEventArgs e)
        {
            if (e.Index == 0)
            {
                LbTitle.Text = "HOME";
                MyListView.BindingContext = new Finimpresa.ViewModels.ClientiViewModel();
            }

            if (e.Index == 1)
            {
                LbTitle.Text = "NOTIZIE";
                MyListViewnews.BindingContext = new Finimpresa.ViewModels.NewsViewModel();
            }
        }

        private async void PullToRefresh_Refreshing(object sender, EventArgs args)
        {
            pullToRefresh.IsRefreshing = true;
            await Task.Delay(2000);
            MyListView.BindingContext = new Finimpresa.ViewModels.ClientiViewModel();
            pullToRefresh.IsRefreshing = false;
        }

        protected override void OnAppearing()
        {
            BdgNews.BindingContext= new Finimpresa.ViewModels.BadgeViewModel();
            if (BdgNews.BadgeText == "")
            {
                StNews.Padding =new Thickness(0,7,0,0);
                imgnews.HeightRequest = 30;
                imgnews.WidthRequest = 30;
            }
            else
            {
                StNews.Padding = new Thickness(0, 0, 0, 0);
                imgnews.HeightRequest = 33;
                imgnews.WidthRequest = 33;
            }
            BindingContext = new Finimpresa.ViewModels.ClientiViewModel();
           // Device.StartTimer(TimeSpan.FromSeconds(1), () =>
          //  {
                //shimmer.IsActive = false;
               // return false;
           // });
            base.OnAppearing();
        }

      //  private async void MyListView_ItemTapped(object sender, Syncfusion.ListView.XForms.ItemTappedEventArgs e)
      //  {
      //      UserDialogs.Instance.ShowLoading("Caricamento in corso...");
      //      if (string.IsNullOrEmpty(filterText.Text))
      //      {
      //          filterText.IsVisible = false;
      //      }
      //      var valuename = (PropertyClienti)e.ItemData;
      //      Parametri.Codfisc = valuename.CdFc;
      //      await Navigation.PushAsync(new CategoryPdf(Parametri.Codfisc));
      //      UserDialogs.Instance.HideLoading();
      //  }

        SearchBar searchBar = null;
        private void filterText_TextChanged(object sender, TextChangedEventArgs e)
        {
            searchBar = (sender as SearchBar);
            if (MyListView.DataSource != null)
            {
                MyListView.DataSource.Filter = FilterContacts;
                MyListView.DataSource.RefreshFilter();
            }
        }

        private bool FilterContacts(object obj)
        {
            if (searchBar == null || searchBar.Text == null)
                return true;

            var contacts = obj as PropertyClienti;
            if (contacts.Denominazione.ToLower().Contains(searchBar.Text.ToLower())
                 || contacts.Denominazione.ToLower().Contains(searchBar.Text.ToLower()))
                return true;
            else
                return false;
        }

        SearchBar searchBarnews = null;
        private void filterTextnews_TextChanged(object sender, TextChangedEventArgs e)
        {
            searchBarnews = (sender as SearchBar);
            if (MyListViewnews.DataSource != null)
            {
                MyListViewnews.DataSource.Filter = FilterNews;
                MyListViewnews.DataSource.RefreshFilter();
            }
        }

        private bool FilterNews(object obj)
        {
            if (searchBarnews == null || searchBarnews.Text == null)
                return true;

            var news = obj as Notizie;
            if (news.Oggetto.ToLower().Contains(searchBarnews.Text.ToLower())
                 || news.Oggetto.ToLower().Contains(searchBarnews.Text.ToLower()))
                return true;
            else
                return false;
        }

        private void MenuItem1_Clicked(object sender, EventArgs e)
        {
            switch (LbTitle.Text)
            {
                case "HOME":
                    filterText.IsVisible = true;
                    break;
                case "NOTIZIE":
                    filterTextnews.IsVisible = true;
                    break ;
            }
        }

        private async void SfEffectsView_AnimationCompleted(object sender, EventArgs e)
        {
            UserDialogs.Instance.ShowLoading("Caricamento in corso...");
            if (string.IsNullOrEmpty(filterText.Text))
            {
                filterText.IsVisible = false;
            }
            var effectsView = sender as SfEffectsView;
            var valuename = effectsView.BindingContext as PropertyClienti;
            Parametri.Codfisc = valuename.CdFc;
            await Navigation.PushAsync(new CategoryPdf(Parametri.Codfisc));
            UserDialogs.Instance.HideLoading();
        }

        private async void SfEffectsView_AnimationCompleted_1(object sender, EventArgs e)
        {
            UserDialogs.Instance.ShowLoading("Caricamento in corso...");
            if (string.IsNullOrEmpty(filterTextnews.Text))
            {
                filterTextnews.IsVisible = false;
            }
            var effectsView = sender as SfEffectsView;
            var value = effectsView.BindingContext as Notizie;
            await Navigation.PushAsync(new News(value.Id));
            UserDialogs.Instance.HideLoading();
        }
    }
}