﻿using Syncfusion.Pdf.Graphics;
using Syncfusion.XForms.TabView;
using System;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data.SqlClient;
using System.Reflection;
using System.Runtime.CompilerServices;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace Finimpresa.ViewModels
{
    class ClientiViewModel
    {
        public ObservableCollection<PropertyClienti> PropertyClientis { get; set; }
        public ClientiViewModel()
        {
            PropertyClientis = new ObservableCollection<PropertyClienti>();
            try
            {
                using (var connection = new SqlConnection(Connessione.Path))
                {
                    connection.Open();
                    var command = connection.CreateCommand();
                    string sql = string.Empty;
                    if(Parametri.Master == true)
                    {
                        sql = "SELECT Key_cf, App_Denominazione, App_Mail,App_Coll,App_Check_Gestore FROM Clienti_App WHERE App_Master='false' ORDER BY App_Denominazione";
                    }
                    else
                    {
                        sql= "SELECT Key_cf, App_Denominazione, App_Mail,App_Coll,App_Check_Gestore FROM Clienti_App WHERE App_Coll = @cf and App_Check_Gestore='false' ORDER BY App_Denominazione";
                    }
                    command.CommandText = sql;
                    command.Parameters.AddWithValue("@cf", Parametri.CodfiscLog);
                    command.Parameters.AddWithValue("@chk", Parametri.CheckID);
                    int contarow = 0;
                    using (var reader = command.ExecuteReader())
                    {
                        while (reader.Read())
                  
                        {
                            string strmail = string.Empty;
                            
                            if (reader.GetSqlString(2) == "0")
                            {
                                strmail = "Email non presente";
                            }
                            else
                            {
                                strmail = Convert.ToString(reader.GetSqlString(2));
                            }

                            contarow += 1;

                            PropertyClientis.Add(new PropertyClienti { CdFc = "Codice fiscale: " + reader.GetString(0), 
                                                                       Denominazione = reader.GetString(1), 
                                                                       Email ="Email: " + strmail,
                                                                       Contatore = contarow,
                                                                       IsActive=true});
                           
                        }
                           connection.Close();
                           return;
                    }
                }
               
            }
            catch (Exception)
            {
            }

        }

    }

   
}